/*
 ## Cypress Antioch Firmware:
 ## USB Module source file (cyanfwserial.c)
 ## ===========================
 ##
 ##  Copyright Cypress Semiconductor Corporation, 2006-2007,
 ##  All Rights Reserved
 ##  UNPUBLISHED, LICENSED SOFTWARE.
 ##
 ##  CONFIDENTIAL AND PROPRIETARY INFORMATION
 ##  WHICH IS THE PROPERTY OF CYPRESS.
 ##
 ##  Use of this file is governed
 ##  by the license agreement included in the file
 ##
 ##     <install>/license/license.txt
 ##
 ##  where <install> is the Cypress software
 ##  installation root directory path.
 ##
 ## ===========================
*/

#include "fx2.h"
#include "fx2regs.h"
#include "syncdly.h"            // SYNCDELAY macro
#include <cyanfwserial.h>


#ifdef CYANFW_SERIAL

void CyAnFwSerial_Init()
{
	T2CON = 0x34 ;
	RCAP2H  = 0xFF ;
	RCAP2L = 0xD9 ;
	SCON0 = 0x5A ;
	TI = 1;

	CyAnFwSerial_XmitString("\r\n-> ") ;
}

void CyAnFwSerial_XmitChar(char ch) reentrant
{
	while (TI == 0) ;
	TI = 0 ;
	SBUF0 = ch ;
}

void CyAnFwSerial_XmitHex1(BYTE b)
{
	if (b < 10)
		CyAnFwSerial_XmitChar(b + '0') ;
	else
		CyAnFwSerial_XmitChar(b - 10 + 'A') ;
}

void CyAnFwSerial_XmitHex2(BYTE b)
{
	CyAnFwSerial_XmitHex1((b >> 4) & 0x0f) ;
	CyAnFwSerial_XmitHex1(b & 0x0f) ;
}

void CyAnFwSerial_XmitHex4(WORD w)
{
	CyAnFwSerial_XmitHex2((w >> 8) & 0xff) ;
	CyAnFwSerial_XmitHex2(w & 0xff) ;
}

void CyAnFwSerial_XmitString(char *str) reentrant
{
	while (*str)
		CyAnFwSerial_XmitChar(*str++) ;
}

#endif

