/*
 ## Cypress Antioch Firmware:
 ## USB Module source file (cyanfwusb.c)
 ## ===========================
 ##
 ##  Copyright Cypress Semiconductor Corporation, 2006-2007,
 ##  All Rights Reserved
 ##  UNPUBLISHED, LICENSED SOFTWARE.
 ##
 ##  CONFIDENTIAL AND PROPRIETARY INFORMATION
 ##  WHICH IS THE PROPERTY OF CYPRESS.
 ##
 ##  Use of this file is governed
 ##  by the license agreement included in the file
 ##
 ##     <install>/license/license.txt
 ##
 ##  where <install> is the Cypress software
 ##  installation root directory path.
 ##
 ## ===========================
*/

#ifndef _INCLUDED_CYANFWSERIAL_H

#ifdef CYANFW_SERIAL

#define CYANFW_SERIAL_SENDCHAR(ch) CyAnFwSerial_XmitChar(ch)
#define CYANFW_SERIAL_SENDHEX2(v) CyAnFwSerial_XmitHex2(v)
#define CYANFW_SERIAL_SENDHEX4(v) CyAnFwSerial_XmitHex4(v)
#define CYANFW_SERIAL_SENDSTRING(s) CyAnFwSerial_XmitString(s)

extern void
CyAnFwSerial_Init() ;

extern void
CyAnFwSerial_XmitChar(char ch) reentrant;

extern void
CyAnFwSerial_XmitHex1(BYTE b) ;

extern void
CyAnFwSerial_XmitHex2(BYTE b) ;

extern void
CyAnFwSerial_XmitHex4(WORD w) ;

extern void
CyAnFwSerial_XmitString(char *str) reentrant;

#else

#define CYANFW_SERIAL_SENDCHAR(ch)
#define CYANFW_SERIAL_SENDHEX2(v)
#define CYANFW_SERIAL_SENDHEX4(v)
#define CYANFW_SERIAL_SENDSTRING(s) 

#endif

#endif

