//-----------------------------------------------------------------------------
//   File:      bulkext.c
//   Contents:  Hooks required to implement USB peripheral function.
//
// $Archive: /USB/Examples/FX2LP/bulkext/bulkext.c $
// $Date: 3/23/05 2:53p $
// $Revision: 3 $
//
//
//-----------------------------------------------------------------------------
// Copyright 2003, Cypress Semiconductor Corporation
//-----------------------------------------------------------------------------
#pragma NOIV               // Do not generate interrupt vectors
#include "fx2.h"
#include "fx2regs.h"
#include "syncdly.h"            // SYNCDELAY macro
#include "iic.h"
#include "i2c_sw.h"
#include "cyanfwserial.h"
#include "gpio.h"

extern BOOL GotSUD;             // Received setup data flag
extern BOOL GotEP0OUTD;             // Received setup data flag
extern BOOL GotEP1OUTD;             // Received setup data flag
extern BOOL Sleep;
extern BOOL Rwuen;
extern BOOL Selfpwr;

extern void GpifInit( void );

int gvalue = 0;

BYTE Configuration;             // Current configuration
BYTE AlternateSetting;          // Alternate settings


#define TV_CMD_WRITE_LS_I2C	5
#define TV_CMD_READ_LS_I2C		4
#define TV_CMD_WRITE_EX_I2C	2
#define TV_CMD_READ_EX_I2C		1

#define POS_RES					0x02
#define POS_RDATALEN			0x03
#define POS_RDATASTART			0x04
#define POS_CMD					0x04
#define POS_I2CADDR				0x05
#define POS_CDATALEN			0x06
#define POS_CDATASTART			0x07

#define RES_SUCCESS				0x00
#define RES_FAILED				0xfd
BYTE xdata DataRcv[60];
void testI2Cpin(void)
{
	return;
	PA0 = 1;
	_nop_();_nop_();
	_nop_();_nop_();

	PA0 = 0;
	_nop_();_nop_();
	_nop_();_nop_();

	PA1 = 1;
	_nop_();_nop_();
	_nop_();_nop_();
	PA1 = 0;
	_nop_();_nop_();
	_nop_();_nop_();
}


// I2C
#define SECADDR_INDEX	2
#define SUBADRR_TYPE	3
#define SUBADDR_IDX_L	4
#define SUBADDR_IDX_H	5
#define DATASIZE_INDEX	6

// Gpio
#define PINNUM_INDEX	3
#define REGADDR_INDEX	4

#define RESIDX_SECADDR	1
#define RESIDX_REGADDR	2
#define RESIDX_LEN		3
#define RESIDX_RESULT	4
#define RESIDX_VAL		5
#define RESIDX_BYTE6	6
#define RESIDX_BYTE7	7

#define RESVAL_OK		1
#define RESVAL_ERR		0

// I2C param
BYTE DevAddr;
BYTE subType;
BYTE Len;
WORD subAddr;

// GPIO param
//BYTE Port;
//BYTE PinNum;

BOOL ProcessVendorCommand(void)
{
	int i;
	i = 0;
	EP0BUF[0] = 0;
	if(SETUPDAT[0]&0x80)
	{																 
		if (SETUPDAT[1] == 0xA3) 
		{
			/*Read*/
			DevAddr = SETUPDAT[SECADDR_INDEX] >> 1;
			subType = SETUPDAT[SUBADRR_TYPE];
			subAddr = (SETUPDAT[SUBADDR_IDX_H] << 8) | SETUPDAT[SUBADDR_IDX_L];
			Len = SETUPDAT[DATASIZE_INDEX];

			//DataRcv[0] = SETUPDAT[REGADDR_INDEX];
			
			I2CRead(DevAddr, subType, subAddr, Len, DataRcv);

			for(i=0;i<Len;i++) 
			{
				EP0BUF[i] = DataRcv[i];
			}
			
			EP0BCH = 0;
			EP0BCL = Len;
		}

		else if (SETUPDAT[1] == 0xA4) // GPIO read
		{				
/*
			if (SETUPDAT[SECADDR_INDEX] == 0x0D)
			{
				GPIO_Configure_PortD(3, 0);
				EP0BUF[0] = GPIO_Read_PortD(3);
				EP0BUF[1] = RESVAL_OK;
			}
			else
			{
				EP0BUF[0] = 0xCC;
				EP0BUF[1] = RESVAL_ERR;				
			}

			EP0BUF[2] = SETUPDAT[PINNUM_INDEX];
			EP0BUF[3] = SETUPDAT[SECADDR_INDEX];
						
			EP0BCH = 0;
			EP0BCL = 4;
*/
		}
		else
		{
			// do nothing
		}
	}
	else
	{
		if (SETUPDAT[1] == 0xA3)
		{
			/*Write*/
			DevAddr = SETUPDAT[SECADDR_INDEX];
			subType = SETUPDAT[SUBADRR_TYPE];
			subAddr = (SETUPDAT[SUBADDR_IDX_H] << 8) | SETUPDAT[SUBADDR_IDX_L];
			Len = SETUPDAT[DATASIZE_INDEX];
			//DataRcv[0] = SETUPDAT[REGADDR_INDEX];

			EP0BCH = 0;
			EP0BCL = 64;
			SYNCDELAY;
			while(EP0BCL != Len)
			{
				SYNCDELAY;
			}
			for(i=0;i<Len;i++)
			{
				DataRcv[i] = EP0BUF[i];
			}

			DevAddr = DevAddr>>1;
			I2CWrite(DevAddr, subType, subAddr, Len, DataRcv);

		} else if (SETUPDAT[1] == 0xA4) { // GPIO Write

			if (SETUPDAT[SECADDR_INDEX] == 0x0D)
			{
				GPIO_Configure_PortD(SETUPDAT[PINNUM_INDEX], 1);   // set to output
				GPIO_Write_PortD(SETUPDAT[PINNUM_INDEX], SETUPDAT[REGADDR_INDEX]);
				EP0BUF[RESIDX_RESULT] = RESVAL_OK;
			}
		}
		else
		{
			// do nothing
		}		
	}

	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;
	SYNCDELAY;

	return TRUE;

}


//-----------------------------------------------------------------------------
// Task Dispatcher hooks
//   The following hooks are called by the task dispatcher.
//-----------------------------------------------------------------------------

void TD_Init(void)             // Called once at startup
{
   // set the CPU clock to 48MHz
   CPUCS = ((CPUCS & ~bmCLKSPD) | bmCLKSPD1) ;

   // set the slave FIFO interface to 48MHz
   IFCONFIG = 0xCB; 

  // Registers which require a synchronization delay, see section 15.14
  // FIFORESET        FIFOPINPOLAR
  // INPKTEND         OUTPKTEND
  // EPxBCH:L         REVCTL
  // GPIFTCB3         GPIFTCB2
  // GPIFTCB1         GPIFTCB0
  // EPxFIFOPFH:L     EPxAUTOINLENH:L
  // EPxFIFOCFG       EPxGPIFFLGSEL
  // PINFLAGSxx       EPxFIFOIRQ
  // EPxFIFOIE        GPIFIRQ
  // GPIFIE           GPIFADRH:L
  // UDMACRCH:L       EPxGPIFTRIG
  // GPIFTRIG
  
  // Note: The pre-REVE EPxGPIFTCH/L register are affected, as well...
  //      ...these have been replaced by GPIFTC[B3:B0] registers

  // default: all endpoints have their VALID bit set
  // default: TYPE1 = 1 and TYPE0 = 0 --> BULK  
  // default: EP2 and EP4 DIR bits are 0 (OUT direction)
  // default: EP6 and EP8 DIR bits are 1 (IN direction)
  // default: EP2, EP4, EP6, and EP8 are double buffered

  // we are just using the default values, yes this is not necessary...
  EP1OUTCFG = 0xA0;
  EP1INCFG = 0xA0;
  SYNCDELAY;                    // see TRM section 15.14

  REVCTL = 0x03; // REVCTL.0 and REVCTL.1 set to 1
  SYNCDELAY;

  EP2CFG = 0xD8; // EP2 is DIR=IN, TYPE=ISOC,SIZE=1024,BUF x4
  SYNCDELAY;
	FIFORESET = 0x80; // Reset the FIFO
	SYNCDELAY;
	FIFORESET = 0x02;
	SYNCDELAY;
	FIFORESET = 0x04;
	SYNCDELAY;
	FIFORESET = 0x06;
	SYNCDELAY;
	FIFORESET = 0x08;
	SYNCDELAY;
	FIFORESET = 0x00;
	SYNCDELAY;
	EP2FIFOCFG = 0x8C; // EP2 is INFM = 1, AUTOOUT=0, AUTOIN=1, ZEROLEN=1, WORDWIDE=0
	//EP2FIFOCFG = 0x88; // EP2 is INFM = 1, AUTOOUT=0, AUTOIN=1, ZEROLEN=0, WORDWIDE=0
	//EP2FIFOCFG = 0x0C; // EP2 is AUTOOUT=0, AUTOIN=1, ZEROLEN=1, WORDWIDE=0
	SYNCDELAY;
	EP4FIFOCFG = 0x0C; // EP4 is AUTOOUT=0, AUTOIN=1, ZEROLEN=1, WORDWIDE=0
	SYNCDELAY;
	EP6FIFOCFG = 0x0C; // EP6 is AUTOOUT=0, AUTOIN=1, ZEROLEN=1, WORDWIDE=0
	SYNCDELAY;
	EP8FIFOCFG = 0x0C; // EP8 is AUTOOUT=0, AUTOIN=1, ZEROLEN=1, WORDWIDE=0
	SYNCDELAY;
	PINFLAGSAB = 0x00; 	// defines FLAGA as prog-level flag, pointed to by FIFOADR[1:0]
	SYNCDELAY; 			// FLAGB as full flag, as pointed to by FIFOADR[1:0]
	
	PINFLAGSCD = 0x00; 	// FLAGC as empty flag, as pointed to by FIFOADR[1:0] 
						// won't generally need FLAGD
	PORTACFG = 0x00; 	// used PA7/FLAGD as a port pin, not as a FIFO flag
	SYNCDELAY;
	FIFOPINPOLAR = 0x00; // set all slave FIFO interface pins as active low
	
	SYNCDELAY;
	EP2AUTOINLENH = 0x04; // EZ-USB automatically commits data in 1024-byte chunks
	SYNCDELAY;
	EP2AUTOINLENL = 0x00;
	
	SYNCDELAY;
	EP2FIFOPFH = 0x80; // you can define the programmable flag (FLAGA)
	SYNCDELAY; // to be active at the level you wish
	EP2FIFOPFL = 0x00;     
  // enable dual autopointer feature
  AUTOPTRSETUP |= 0x01;

}


void TD_Poll(void)              // Called repeatedly while the device is idle
{
}

BOOL TD_Suspend(void)          // Called before the device goes into suspend mode
{
   return(TRUE);
}

BOOL TD_Resume(void)          // Called after the device resumes
{
   return(TRUE);
}

//-----------------------------------------------------------------------------
// Device Request hooks
//   The following hooks are called by the end point 0 device request parser.
//-----------------------------------------------------------------------------

BOOL DR_GetDescriptor(void)
{
   return(TRUE);
}

BOOL DR_SetConfiguration(void)   // Called when a Set Configuration command is received
{
   Configuration = SETUPDAT[2];
   return(TRUE);            // Handled by user code
}

BOOL DR_GetConfiguration(void)   // Called when a Get Configuration command is received
{
   EP0BUF[0] = Configuration;
   EP0BCH = 0;
   EP0BCL = 1;
   return(TRUE);            // Handled by user code
}

BOOL DR_SetInterface(void)       // Called when a Set Interface command is received
{
   AlternateSetting = SETUPDAT[2];
   return(TRUE);            // Handled by user code
}

BOOL DR_GetInterface(void)       // Called when a Set Interface command is received
{
   EP0BUF[0] = AlternateSetting;
   EP0BCH = 0;
   EP0BCL = 1;
   return(TRUE);            // Handled by user code
}

BOOL DR_GetStatus(void)
{
   return(TRUE);
}

BOOL DR_ClearFeature(void)
{
   return(TRUE);
}

BOOL DR_SetFeature(void)
{
   return(TRUE);
}

BOOL DR_VendorCmnd(void)
{
   return(TRUE);
}

//-----------------------------------------------------------------------------
// USB Interrupt Handlers
//   The following functions are called by the USB interrupt jump table.
//-----------------------------------------------------------------------------

// Setup Data Available Interrupt Handler
void ISR_Sudav(void) interrupt 0
{
   GotSUD = TRUE;            // Set flag
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSUDAV;         // Clear SUDAV IRQ
}

// Setup Token Interrupt Handler
void ISR_Sutok(void) interrupt 0
{
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSUTOK;         // Clear SUTOK IRQ
}

void ISR_Sof(void) interrupt 0
{
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSOF;            // Clear SOF IRQ
}

void ISR_Ures(void) interrupt 0
{
	if(EZUSB_HIGHSPEED())
	{
		pConfigDscr = pHighSpeedConfigDscr;
		pOtherConfigDscr = pFullSpeedConfigDscr;
	}
	else
	{
		pConfigDscr = pFullSpeedConfigDscr;
		pOtherConfigDscr = pHighSpeedConfigDscr;
	}
	((CONFIGDSCR xdata*)pConfigDscr)->type = CONFIG_DSCR;
	((CONFIGDSCR xdata*)pOtherConfigDscr)->type = OTHERSPEED_DSCR;

	EZUSB_IRQ_CLEAR();
	USBIRQ = bmURES; // Clear URES IRQ
}

void ISR_Susp(void) interrupt 0
{
   Sleep = TRUE;
   EZUSB_IRQ_CLEAR();
   USBIRQ = bmSUSP;
}

void ISR_Highspeed(void) interrupt 0
{
	if(EZUSB_HIGHSPEED())
	{
		pConfigDscr = pHighSpeedConfigDscr;
		pOtherConfigDscr = pFullSpeedConfigDscr;
	}
	else
	{
		pConfigDscr = pFullSpeedConfigDscr;
		pOtherConfigDscr = pHighSpeedConfigDscr;
	}
	((CONFIGDSCR xdata*)pConfigDscr)->type = CONFIG_DSCR;
	((CONFIGDSCR xdata*)pOtherConfigDscr)->type = OTHERSPEED_DSCR;

	EZUSB_IRQ_CLEAR();
	USBIRQ = bmHSGRANT;
}
void ISR_Ep0ack(void) interrupt 0
{
}
void ISR_Stub(void) interrupt 0
{
}
void ISR_Ep0in(void) interrupt 0
{
}
void ISR_Ep0out(void) interrupt 0
{
	EZUSB_IRQ_CLEAR();
	EPIRQ = bmBIT1;
	GotEP0OUTD = TRUE;		  
}
void ISR_Ep1in(void) interrupt 0
{

	EZUSB_IRQ_CLEAR();
	EPIRQ = bmBIT2;
}
void ISR_Ep1out(void) interrupt 0
{

	EZUSB_IRQ_CLEAR();
	EPIRQ = bmBIT3;
	GotEP1OUTD = TRUE;		  
}
void ISR_Ep2inout(void) interrupt 0
{
}
void ISR_Ep4inout(void) interrupt 0
{
}
void ISR_Ep6inout(void) interrupt 0
{
}
void ISR_Ep8inout(void) interrupt 0
{
}
void ISR_Ibn(void) interrupt 0
{
}
void ISR_Ep0pingnak(void) interrupt 0
{
}
void ISR_Ep1pingnak(void) interrupt 0
{
}
void ISR_Ep2pingnak(void) interrupt 0
{
}
void ISR_Ep4pingnak(void) interrupt 0
{
}
void ISR_Ep6pingnak(void) interrupt 0
{
}
void ISR_Ep8pingnak(void) interrupt 0
{
}
void ISR_Errorlimit(void) interrupt 0
{
}
void ISR_Ep2piderror(void) interrupt 0
{
}
void ISR_Ep4piderror(void) interrupt 0
{
}
void ISR_Ep6piderror(void) interrupt 0
{
}
void ISR_Ep8piderror(void) interrupt 0
{
}
void ISR_Ep2pflag(void) interrupt 0
{
}
void ISR_Ep4pflag(void) interrupt 0
{
}
void ISR_Ep6pflag(void) interrupt 0
{
}
void ISR_Ep8pflag(void) interrupt 0
{
}
void ISR_Ep2eflag(void) interrupt 0
{
}
void ISR_Ep4eflag(void) interrupt 0
{
}
void ISR_Ep6eflag(void) interrupt 0
{
}
void ISR_Ep8eflag(void) interrupt 0
{
}
void ISR_Ep2fflag(void) interrupt 0
{
}
void ISR_Ep4fflag(void) interrupt 0
{
}
void ISR_Ep6fflag(void) interrupt 0
{
}
void ISR_Ep8fflag(void) interrupt 0
{
}
void ISR_GpifComplete(void) interrupt 0
{
}
void ISR_GpifWaveform(void) interrupt 0
{
}
